{% extends 'layout.html' %}

{% block content %}
    <div class="flex flex-col flex-wrap gap-8 justify-center items-center py-2">
        <div class="flex flex-row place-content-center gap-2 sm:gap-8 flex-wrap ">
            <a href="#" class="type-filter bg-yellow hover:opacity-90 px-4 md:px-8 py-4 rounded-lg text-grey-dark" data-type="all">All</a>
            <a href="#" class="type-filter bg-yellow hover:opacity-90 px-4 md:px-8 py-4 rounded-lg text-grey-dark" data-type="drink">Drinks</a>
            <a href="#" class="type-filter bg-yellow hover:opacity-90 px-4 md:px-8 py-4 rounded-lg text-grey-dark" data-type="snack">Snacks</a>
            <a href="#" class="type-filter bg-yellow hover:opacity-90 px-4 md:px-8 py-4 rounded-lg text-grey-dark" data-type="other">Other</a>
        </div>
    </div>

    <div class="flex justify-center py-4">
        <input type="text" id="searchBar" placeholder="Search products..." class="px-4 py-2 border rounded-lg w-1/2 text-black">
    </div>

    <div class="grid md:grid-cols-2 lg:grid-cols-3 gap-6">
        {% for product in products %}
            <div class="grid grid-cols-4 items-center px-8 py-8 bg-grey-dark gap-4 rounded-lg hover:bg-grey-light active:ring active:ring-yellow product-link" data-type="{{ product['type'] | lower }}" data-id="{{ product['id'] }}" data-name="{{ product['name'] | lower }}">
                {% if product['picture'] == None %}
                    <div class="w-12 h-12 rounded-md bg-yellow"></div>
                {% else %}
                    <img class="w-12 h-12 rounded-md" src="https://api.tuks.dev{{ product['picture'] }}" alt="">
                {% endif %}
                <div class="col-span-2 flex flex-col">
                    <p class="text-yellow">{{ product['name'] }}</p>
                    <p>{{ "€ %.2f"|format(product['price'] * session['discount']) }}</p>
                </div>
                <a href="/info/{{ product['id'] }}" class="col-span-1 flex flex-col justify-center items-center">
                    <i class="stroke-yellow w-10 h-10" lucide="info"></i>
                </a>
            </div>
        {% endfor %}
    </div>

        <a href="/cart" class="absolute bottom-24 right-10 p-4 flex justify-center items-center rounded-full bg-yellow">
            <i class="stroke-grey-dark stroke-4 w-10 h-10" lucide="shopping-cart"></i>
            <div class="absolute -top-2 -right-2 w-8 h-8 flex justify-center items-center rounded-full bg-white animate-[bounce_300ms_ease_1]">
                <p class="text-grey-dark text-xl text-center" id="shopping-cart-number">{{ session['cart']|length }}</p>
            </div>
        </a>

    <script>
        window.onload = function() {

        // Filter by product type
            document.querySelectorAll('.type-filter').forEach(function(filter) {
                filter.addEventListener('click', function(event) {
                    event.preventDefault();
                    const type = this.getAttribute('data-type');
                    
                    document.querySelectorAll('.product-link').forEach(function(product) {
                        const productType = product.getAttribute('data-type');
                        if (type === 'all' || productType === type) {
                            product.style.display = 'grid';
                        } else {
                            product.style.display = 'none';
                        }
                    });
                });
            });
            document.querySelectorAll('.product-link').forEach(function(link) {
                link.addEventListener('click', function(event) {
                    if (event.target.closest('a[href]')) {
                        return;
                    }
                    event.preventDefault();

                    let productId = this.getAttribute('data-id');

                    fetch(`/cart/${productId}`, {
                        method: 'POST',
                        headers: {
                            'Content-Type': 'application/json',
                            'X-Requested-With': 'XMLHttpRequest'
                        },
                    }).then(response => response.json()).then(data => {
                        let cartCountElement = document.getElementById('shopping-cart-number');
                        cartCountElement.textContent = data.cart_count;
                    }).catch(error => {
                        console.error('Error adding product to cart:', error);
                        alert(error);
                    });
                });
            });
            document.getElementById('searchBar').addEventListener('input', function () {
                const searchTerm = this.value.toLowerCase();
                const products = document.querySelectorAll('.product-link');
            
                products.forEach(product => {
                    const productName = product.getAttribute('data-name');
                    if (productName.includes(searchTerm)) {
                        product.style.display = 'grid';
                    } else {
                        product.style.display = 'none';
                    }
                });
            });
        };
    </script>
{% endblock content %}
